Package net.commoble.exmachina.api

# Record Class NodeShape.SideSide

java.lang.Object
java.lang.Record
net.commoble.exmachina.api.NodeShape.SideSide

Record Components:
  `face` - Direction from the center of the blockpos to the face on which the node lies
  `side` - Direction from the center of the primary face to the neighbor in parallel with that face

All Implemented Interfaces:
  `NodeShape`

Enclosing interface:
  `NodeShape`

public static record NodeShape.SideSide(net.minecraft.core.Direction face, net.minecraft.core.Direction side) extends Record implements NodeShape
NodeShape which represents a node which lies on the internal face of a BlockPos but on touches one of its four orthagonal neighbors

## Nested Class Summary

## Nested classes/interfaces inherited from interface net.commoble.exmachina.api.NodeShape

`NodeShape.Cube, NodeShape.Side, NodeShape.SideSide`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final com.mojang.serialization.Codec<NodeShape.SideSide>`
`CODEC`
"shape": {"face": "north", "side": "up"}

### Fields inherited from interface net.commoble.exmachina.api.NodeShape

`STREAM_CODEC`

## Constructor Summary

Constructors
Constructor
Description
`SideSide(net.minecraft.core.Direction face, net.minecraft.core.Direction side)`
Creates an instance of a `SideSide` record class.

## Method Summary

Modifier and Type
Method
Description
`final boolean`
`equals(Object o)`
Indicates whether some other object is "equal to" this one.
`net.minecraft.core.Direction`
`face()`
Returns the value of the `face` record component.
`final int`
`hashCode()`
Returns a hash code value for this object.
`boolean`
`isValidFor(NodeShape otherNode)`
Returns true if this targeted NodeShape is usable when a preferred node is requested for a connection.
`net.minecraft.core.Direction`
`side()`
Returns the value of the `side` record component.
`final String`
`toString()`
Returns a string representation of this record class.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### CODEC

public static final com.mojang.serialization.Codec<NodeShape.SideSide> CODEC

     "shape": {"face": "north", "side": "up"}

## Constructor Details

### SideSide

public SideSide(net.minecraft.core.Direction face, net.minecraft.core.Direction side)
Creates an instance of a `SideSide` record class.

Parameters:
  `face` - the value for the `face` record component
  `side` - the value for the `side` record component

## Method Details

### isValidFor

public boolean isValidFor(NodeShape otherNode)
Description copied from interface: `NodeShape`
Returns true if this targeted NodeShape is usable when a preferred node is requested for a connection.

Specified by:
  `isValidFor` in interface `NodeShape`
Parameters:
  `otherNode` - NodeShape which another node is trying to form a connection to
Returns:
  true if this targeted NodeShape is usable when a preferred node is requested for a connection

### toString

public final String toString()
Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.

Specified by:
  `toString` in class `Record`
Returns:
  a string representation of this object

### hashCode

public final int hashCode()
Returns a hash code value for this object. The value is derived from the hash code of each of the record components.

Specified by:
  `hashCode` in class `Record`
Returns:
  a hash code value for this object

### equals

public final boolean equals(Object o)
Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.

Specified by:
  `equals` in class `Record`
Parameters:
  `o` - the object with which to compare
Returns:
  `true` if this object is the same as the `o` argument; `false` otherwise.

### face

public net.minecraft.core.Direction face()
Returns the value of the `face` record component.

Returns:
  the value of the `face` record component

### side

public net.minecraft.core.Direction side()
Returns the value of the `side` record component.

Returns:
  the value of the `side` record component